<?php
/**
 * PHPDevShell is a RAD Framework aimed at developing administrative applications.
 *
 * @package PHPDevShell
 * @link http://www.phpdevshell.org
 * @copyright Copyright (C) 2007 Jason Schoeman, All rights reserved.
 * @license GNU/LGPL, see readme/licensed_under_lgpl or http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html
 * @author Jason Schoeman, Contact: titan [at] phpdevshell [dot] org.
 *
 * Copyright notice: See readme/notice
 * By using PHPDevShell you agree to notice and license, if you dont agree to this notice/license you are not allowed to use PHPDevShell.
 */
/**
 * Exception extenstion.
 */
class PHPDS_exception extends Exception
{
	protected $ignoreLines = 0;
	protected $extendedMessage = '';

	public function __construct($message = "", $code = 0, $previous = null)
	{
		if (is_a($previous, 'Exception')) {
			$this->file = $previous->getFile();
			$this->line = $previous->getLine();
			$this->message .= $previous->getMessage();
			$this->trace = $previous->getTrace();
			$this->code = $previous->getCode();
			if (empty($this->code)) $this->code = $code;
			if (is_a($previous, 'PHPDS_exception')) $this->extendedMessage .= $previous->getExtendedMessage();
			if ($message) $this->extendedMessage .= $message;
		} else {
			$this->message = $message;
			$this->code = $code;
		}

		/*$this->ignoreLines = $code;
		$this->code = 0;*/
	}

	public function getignoreLines()
	{
		return $this->ignoreLines;
	}

	public function getExtendedMessage()
	{
		return $this->extendedMessage;
	}

	public function getExtendedTrace()
	{
		return empty($this->trace) ? $this->getTrace() : $this->trace;
	}
}

class PHPDS_fatalError extends PHPDS_exception
{
	public function __construct($message = "", $code = 0, $previous = null)
	{
		$error = error_get_last();

		if (isset($error['message'])) $this->message = $error['message'];
		if (isset($error['type'])) $this->code = $error['type'];
		if (isset($error['file'])) $this->file = $error['file'];
		if (isset($error['line'])) $this->line = $error['line'];

		//$this->ignoreLines = 2;
	}
}

class PHPDS_databaseException extends PHPDS_exception {}